// the demo source itself is quite a mess. the main intention is to demonstrate
// the miniengine (miniengine.cpp, h), as a very basic d3d "helper"
// maga a demo forrasa eleg kusza. a lenyeg a miniengine (miniengine.cpp, h)
// demonstralasa, egy egyszeru d3d "helper"-kent

// the source is based on the "createdevice" sample from the d3d sdk.

// bass is Ian Luck's really cool sound(mod/mp3)player.
// check it out at http://www.un4seen.com


// last minute remark: the code does NOT do any vertex/pixel shader version checking!
// megjegyzes: a kod NEM vegez vertex/pixel shader verzioszam ellenorzest!


#include "miniengine/miniengine.h"
#include "demo/shared.h"
#include "demo/sprite.h"
#include "demo/testpart.h"
#include "demo/part2.h"


//-----------------------------------------------------------------------------
// Global variables
//-----------------------------------------------------------------------------

#define Clamp(x, minvalue, maxvalue) ( min( max( (x), (minvalue) ), (maxvalue) ) )
VOID Render()
{
	if (MiniEngine::BeginDraw())
	{
		SHNewFrame();

		if (fPattern<5.0f)
		{
			D3DXVECTOR3 lookFrom, lookAt, lookUp;
			float fFade=1.0f;
			lookUp=D3DXVECTOR3(0.0f, 1.0f, 0.0f);

			const float lookAtOrbit=2.0f;
			const float lookFromOrbit=8.0f;

		// descent
			lookAt=D3DXVECTOR3(0, 3.0f, lookAtOrbit);
			lookFrom=D3DXVECTOR3(0, 35.0f-fPattern*16.0f, lookFromOrbit);

			fFade=fmodf(fPattern, 1.0f);
			fFade=1.0f-(cosf(fFade*D3DX_PI*4.0f)*0.5f+0.5f);
			fFade=fFade*0.6f+0.4f;

		// sloworbit
			float fLocalPattern=fPattern-2.0f;
			float acc= Clamp(fLocalPattern*4.0f, 0.0f, 1.0f);

			acc=cosf(acc*D3DX_PI)*-0.5f+0.5f;

			float atspeed=fLocalPattern*1.7f;
			float fromspeed=fLocalPattern;
			D3DXVec3Lerp(&lookAt, &lookAt, &D3DXVECTOR3(lookAtOrbit*sinf(atspeed), 3.0f, lookAtOrbit*cosf(atspeed)), acc);
			D3DXVec3Lerp(&lookFrom, &lookFrom, &D3DXVECTOR3(lookFromOrbit*sinf(fromspeed), 1.0f, lookFromOrbit*cosf(fromspeed)), acc);
			
			if (fPattern>3.95f && fPattern<5.0f)
			{
				fFade=1.0f-min(1.0f, powf((fPattern-3.95f)*8.0f, 2.0f));
			} else {
				fFade=min(1.0f, fPattern*2.0f);
			}

			SATestRender(0, lookFrom, lookAt, lookUp, fFade);
		} else
		if (fPattern<9.0f)
		{
			float fLocalPattern=fPattern-5.0f;
			const float lookAtOrbit=2.0f;
			const float lookFromOrbit=8.0f;
			D3DXVECTOR3 lookFrom, lookAt, lookUp;
			float fFade=1.0f;
			lookUp=D3DXVECTOR3(0.0f, 1.0f, 0.0f);
			float atspeed=fLocalPattern*1.7f;
			float fromspeed=fLocalPattern;

			lookAt=D3DXVECTOR3(lookAtOrbit*sinf(atspeed), 3.0f, lookAtOrbit*cosf(atspeed));
			lookFrom=D3DXVECTOR3(lookFromOrbit*sinf(fromspeed), 1.0f, lookFromOrbit*cosf(fromspeed));

			if (fLocalPattern>3.75f)
			{
				fFade=(fLocalPattern-3.75f)*3.0f;
				fFade=max(0.0f, 1.0f-fFade*fFade);
			}
			SATestRender(fLocalPattern, lookFrom, lookAt, lookUp, fFade);

		} else
		if (fPattern<13.0f)
		{
			float fLocalPattern=fPattern-9.0f;
			float fBloom=1.3f;
			if (fPattern>12.0f) fBloom+=(fPattern-12.0f)*0.15f;
			if (fPattern>12.9f) fBloom+=pow((fPattern-12.9f)*10.0f, 2.0f)*1.6f;


			float fScale, fBias, fIntensity;
			if (fPattern<11.0f)
			{
				fScale=-1.0f;
				fBias=1.0f;
				fIntensity=max(0.0f, (fPattern-10.95f)*60.0f);
				fIntensity=max(0.0f, 1.0f-(fIntensity*fIntensity));
			} else {
				fScale=1.0f;
				fBias=0.0f;
				fIntensity=1.0f-min(1.0f, (fPattern-11.0f)*10.0f);
				fIntensity=1.0f+(fIntensity*fIntensity);
			}

			float fsl=fLocalPattern;
			float fAdd1, fAdd2, fAdd3;
			fAdd1=fAdd2=fAdd3=0;

			fAdd1=1.0f-min(1.0f, fmodf(fLocalPattern, 0.5f)*10.0f);
			fLocalPattern-=6.0f/64.0f;
			fAdd2=1.0f-min(1.0f, fmodf(fLocalPattern, 0.5f)*10.0f);
			fLocalPattern-=6.0f/64.0f;
			fAdd3=1.0f-min(1.0f, fmodf(fLocalPattern, 0.5f)*10.0f);

			SAPart2Render(fLocalPattern*0.8f*2.0f-0.4f, fBloom, fScale, fBias, fIntensity, fAdd1, fAdd2, fAdd3);

			if (fsl>3.9f)
			{
				float fAlpha=(fsl-3.9f)/0.1f;
				fAlpha*=fAlpha;
				SADrawSprite("SpriteBlend", (LPDIRECT3DTEXTURE9)MiniEngine::GetTexture("textures/white.dds").GetTexture(), D3DXVECTOR4(0.0f, 0.0f, 1.0f, 1.0f), D3DXVECTOR4(0.0f, 0.0f, 1.0f, 1.0f), D3DXVECTOR4(1.0f, 1.0f, 1.0f, fAlpha));
			}
		} else
		{
			float fLocalPattern=fPattern-13.0f;
			SATestRender2(fLocalPattern);
		}

		MiniEngine::EndDraw();
	} else {
		Sleep(100);
	}
}


//-----------------------------------------------------------------------------
// Name: MsgProc()
// Desc: The window's message handler
//-----------------------------------------------------------------------------
LRESULT WINAPI MsgProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam )
{
    switch( msg )
    {
        case WM_DESTROY:
            PostQuitMessage( 0 );
            return 0;

		case WM_KEYDOWN:
			if (VK_ESCAPE==wParam) PostQuitMessage( 0 );
			return 0;
    }

    return DefWindowProc( hWnd, msg, wParam, lParam );
}


void InitParts()
{
	SHInit();
	SASpriteInit();
	SATestInit();
	SAPart2Init();
}

void TerminateParts()
{
	SAPart2Terminate();
	SATestTerminate();
	SASpriteTerminate();
	SHTerminate();
}

//-----------------------------------------------------------------------------
// Name: WinMain()
// Desc: The application's entry point
//-----------------------------------------------------------------------------
INT WINAPI WinMain( HINSTANCE hInst, HINSTANCE, LPSTR, INT )
{
    // Register the window class
    WNDCLASSEX wc = { sizeof(WNDCLASSEX), CS_CLASSDC, MsgProc, 0L, 0L, 
                      GetModuleHandle(NULL), NULL, NULL, NULL, NULL,
                      "MiniEngine", NULL };

	RegisterClassEx( &wc );

    // Create the application's window
    HWND hWnd = CreateWindow( "MiniEngine", "Tiny little wrapper thingie", 
                              WS_OVERLAPPEDWINDOW, 0, 0, 1024, 768,
                              NULL, NULL, wc.hInstance, NULL );

    // Initialize the miniengine (which will init d3d)
	if (MiniEngine::Init(hWnd))
    { 
        // Show the window
        ShowWindow( hWnd, SW_SHOWDEFAULT );
        UpdateWindow( hWnd );
		ShowCursor(false);

		InitParts();
		SHStart();

		// Enter the message loop
        MSG msg; 
        ZeroMemory( &msg, sizeof(msg) );
        while(( msg.message!=WM_QUIT ) && (fPattern<17.8f))
        {
            if( PeekMessage( &msg, NULL, 0U, 0U, PM_REMOVE ) )
            {
                TranslateMessage( &msg );
                DispatchMessage( &msg );
            }
            else
                Render();
        }

		TerminateParts();
		MiniEngine::Terminate();
    }

    UnregisterClass( "MiniEngine", wc.hInstance );
    return 0;
}
